/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ustasoft.component;

import com.ustasoft.pos.dao.jdbc.AccCoaDao;
import com.ustasoft.pos.dao.jdbc.GudangDao;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.FocusTraversalPolicy;
import java.awt.KeyboardFocusManager;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import pos.MainForm;

/**
 *
 * @author cak-ust
 */
public class FrmSettingPenjualan extends javax.swing.JInternalFrame {
    private Connection conn;
    ResultSet rs=null;
    boolean isNew=false;
    private GeneralFunction fn=new GeneralFunction();
    Properties prop = new Properties();
    InputStream input = null;
    GudangDao gudangDao;
    /**
     * Creates new form FrmInfoPerusahaan
     */
    public FrmSettingPenjualan() {
        initComponents();
        MyKeyListener kListener=new MyKeyListener();
        fn.addKeyListenerInContainer(jPanel1, kListener, txtFocusListener);
        btnSave.addKeyListener(kListener);
        btnKeluar.addKeyListener(kListener);
    }

    public void setConn(Connection c){
        this.conn=c;
        gudangDao=new GudangDao(conn);
    }
    
    private void udfInitForm(){
        
        try {
            rs=conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_UPDATABLE)
                    .executeQuery("select * from m_setting_penjualan ");
            
            if(rs.next()){
                txtKetPembayaran.setText(rs.getString("ket_pembayaran")==null? "": rs.getString("ket_pembayaran"));
                txtCatatanKaki.setText(rs.getString("foot_note_faktur")==null? "": rs.getString("foot_note_faktur"));
                txtDisiapkanOleh.setText(rs.getString("disiapkan_oleh")==null? "": rs.getString("disiapkan_oleh"));
                txtDibuatOleh.setText(rs.getString("dibuat_oleh")==null? "": rs.getString("dibuat_oleh"));
                txtDiperiksaOleh.setText(rs.getString("diperiksa_oleh")==null? "": rs.getString("diperiksa_oleh"));
            }else{
                rs.moveToInsertRow();
                isNew=true;
            }
            
            input = new FileInputStream("setting.properties");

		// load a properties file
            prop.load(input);
        } catch (SQLException ex) {
            Logger.getLogger(FrmSettingPenjualan.class.getName()).log(Level.SEVERE, null, ex);
        } catch (Exception ex) {
            Logger.getLogger(FrmSettingPenjualan.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    private void udfSave(){
        try {
            rs.updateString("ket_pembayaran", txtKetPembayaran.getText());
            rs.updateString("dibuat_oleh", txtDibuatOleh.getText());
            rs.updateString("diperiksa_oleh", txtDiperiksaOleh.getText());
            rs.updateString("disiapkan_oleh", txtDisiapkanOleh.getText());
            rs.updateString("foot_note_faktur", txtCatatanKaki.getText());
            
            if(isNew)
                rs.insertRow();
            else
                rs.updateRow();
            rs.close();
            JOptionPane.showMessageDialog(this, "Update sukses!");
            this.dispose();
        } catch (SQLException ex) {
            Logger.getLogger(FrmSettingPenjualan.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        txtDibuatOleh = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        txtDiperiksaOleh = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtKetPembayaran = new javax.swing.JTextArea();
        txtDisiapkanOleh = new javax.swing.JTextField();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtCatatanKaki = new javax.swing.JTextArea();
        btnSave = new javax.swing.JButton();
        btnKeluar = new javax.swing.JButton();
        panelHeader1 = new com.ustasoft.component.panelHeader();
        jLabel7 = new javax.swing.JLabel();

        setClosable(true);
        setTitle("Setting Penjualan");
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameOpened(evt);
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
        });
        getContentPane().setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setLayout(null);

        jLabel1.setText("Catatan Kaki");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(0, 160, 130, 20);

        jLabel4.setText("Disiapkan Oleh");
        jPanel1.add(jLabel4);
        jLabel4.setBounds(0, 10, 130, 20);

        jLabel5.setText("Dibuat Oleh");
        jPanel1.add(jLabel5);
        jLabel5.setBounds(0, 40, 130, 20);

        txtDibuatOleh.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(txtDibuatOleh);
        txtDibuatOleh.setBounds(130, 40, 360, 22);

        jLabel6.setText("Diperiksa Oleh");
        jPanel1.add(jLabel6);
        jLabel6.setBounds(0, 60, 130, 20);

        txtDiperiksaOleh.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(txtDiperiksaOleh);
        txtDiperiksaOleh.setBounds(130, 60, 360, 22);

        jLabel8.setText("Ket. Pembayaran");
        jPanel1.add(jLabel8);
        jLabel8.setBounds(0, 90, 130, 20);

        txtKetPembayaran.setColumns(20);
        txtKetPembayaran.setRows(5);
        txtKetPembayaran.setText("Pembayaran dengan Transfer, BG/ Cheque,\ndapat ditujukan ke BCA Citraland - Surabaya\nNo. Rek. 8620022200 a/n MARISA");
        jScrollPane1.setViewportView(txtKetPembayaran);

        jPanel1.add(jScrollPane1);
        jScrollPane1.setBounds(130, 90, 360, 70);

        txtDisiapkanOleh.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(txtDisiapkanOleh);
        txtDisiapkanOleh.setBounds(130, 10, 360, 22);

        txtCatatanKaki.setColumns(20);
        txtCatatanKaki.setRows(5);
        jScrollPane2.setViewportView(txtCatatanKaki);

        jPanel1.add(jScrollPane2);
        jScrollPane2.setBounds(130, 160, 360, 50);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 70, 510, 220);

        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/printer.png"))); // NOI18N
        btnSave.setText("Simpan");
        btnSave.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });
        getContentPane().add(btnSave);
        btnSave.setBounds(310, 300, 100, 32);

        btnKeluar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/cancel.png"))); // NOI18N
        btnKeluar.setText("Keluar");
        btnKeluar.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnKeluar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnKeluarActionPerformed(evt);
            }
        });
        getContentPane().add(btnKeluar);
        btnKeluar.setBounds(420, 300, 100, 32);

        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText("Setting Penjualan");

        javax.swing.GroupLayout panelHeader1Layout = new javax.swing.GroupLayout(panelHeader1);
        panelHeader1.setLayout(panelHeader1Layout);
        panelHeader1Layout.setHorizontalGroup(
            panelHeader1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelHeader1Layout.createSequentialGroup()
                .addContainerGap(162, Short.MAX_VALUE)
                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 361, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        panelHeader1Layout.setVerticalGroup(
            panelHeader1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 55, Short.MAX_VALUE)
        );

        getContentPane().add(panelHeader1);
        panelHeader1.setBounds(-5, 0, 535, 55);

        setBounds(0, 0, 543, 365);
    }// </editor-fold>//GEN-END:initComponents

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        udfSave();
    }//GEN-LAST:event_btnSaveActionPerformed

    private void btnKeluarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnKeluarActionPerformed
        try {
            if(rs!=null) 
                rs.close();
            this.dispose();
        } catch (SQLException ex) {
            Logger.getLogger(FrmSettingPenjualan.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_btnKeluarActionPerformed

    private void formInternalFrameOpened(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameOpened
        udfInitForm();
    }//GEN-LAST:event_formInternalFrameOpened

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnKeluar;
    private javax.swing.JButton btnSave;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private com.ustasoft.component.panelHeader panelHeader1;
    private javax.swing.JTextArea txtCatatanKaki;
    private javax.swing.JTextField txtDibuatOleh;
    private javax.swing.JTextField txtDiperiksaOleh;
    private javax.swing.JTextField txtDisiapkanOleh;
    private javax.swing.JTextArea txtKetPembayaran;
    // End of variables declaration//GEN-END:variables

    public class MyKeyListener extends KeyAdapter {
        @Override
        public void keyTyped(java.awt.event.KeyEvent evt) {
            
//            if(getTableSource()==null)
//                return;
            
            if (evt.getSource() instanceof JTextField &&
              ((JTextField)evt.getSource()).getName()!=null &&
              ((JTextField)evt.getSource()).getName().equalsIgnoreCase("textEditor")) {
                fn.keyTyped(evt);

           }

        }
        public void keyPressed(KeyEvent evt) {
            Component ct = KeyboardFocusManager.getCurrentKeyboardFocusManager().getPermanentFocusOwner();
            int keyKode = evt.getKeyCode();
            switch(keyKode){
               case KeyEvent.VK_ENTER : {
                    if(!(ct instanceof JTable))                    {
                        if (!fn.isListVisible()){
                            Component c = findNextFocus();
                            if (c==null) return;
                            c.requestFocus();
                        }else{
                            fn.lstRequestFocus();
                        }
                    }
                    break;
                }
                case KeyEvent.VK_DOWN: {
                    if(!(ct.getClass().getSimpleName().equalsIgnoreCase("JTABLE")))
                        {
                            if (!fn.isListVisible()){
                                Component c = findNextFocus();
                                if (c==null) return;
                                c.requestFocus();
                            }else{
                                fn.lstRequestFocus();
                            }
                            break;
                    }
                }

                case KeyEvent.VK_UP: {
                    if(!(evt.getSource() instanceof JTable)){
                        Component c = findPrevFocus();
                        c.requestFocus();
                    }
                    break;
                }
                case KeyEvent.VK_ESCAPE:{
                    dispose();
                    break;
                }
                
            }
        }

//        @Override
//        public void keyReleased(KeyEvent evt){
//            if(evt.getSource().equals(txtDisc)||evt.getSource().equals(txtQty)||evt.getSource().equals(txtUnitPrice))
//                GeneralFunction.keyTyped(evt);
//        }

        public Component findNextFocus() {
            // Find focus owner
            Component c = KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
            Container root = c == null ? null : c.getFocusCycleRootAncestor();

            if (root != null) {
                FocusTraversalPolicy policy = root.getFocusTraversalPolicy();
                Component nextFocus = policy.getComponentAfter(root, c);
                if (nextFocus == null) {
                    nextFocus = policy.getDefaultComponent(root);
                }
                return nextFocus;
            }
            return null;
        }

        public Component findPrevFocus() {
            // Find focus owner
            Component c = KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
            Container root = c == null ? null : c.getFocusCycleRootAncestor();

            if (root != null) {
                FocusTraversalPolicy policy = root.getFocusTraversalPolicy();
                Component prevFocus = policy.getComponentBefore(root, c);
                if (prevFocus == null) {
                    prevFocus = policy.getDefaultComponent(root);
                }
                return prevFocus;
            }
            return null;
        }
    }
    
    private FocusListener txtFocusListener=new FocusListener() {
        public void focusGained(FocusEvent e) {
            if(e.getSource() instanceof JTextField || e.getSource() instanceof JFormattedTextField){
                ((JTextField)e.getSource()).setBackground(Color.YELLOW);
                if( (e.getSource() instanceof JTextField && ((JTextField)e.getSource()).getName()!=null && ((JTextField)e.getSource()).getName().equalsIgnoreCase("textEditor"))){
                    ((JTextField)e.getSource()).setSelectionStart(0);
                    ((JTextField)e.getSource()).setSelectionEnd(((JTextField)e.getSource()).getText().length());

                }
            }
        }

        public void focusLost(FocusEvent e) {
            if(e.getSource().getClass().getSimpleName().equalsIgnoreCase("JTextField")||
                    e.getSource().getClass().getSimpleName().equalsIgnoreCase("JFormattedTextField")){
                ((JTextField)e.getSource()).setBackground(Color.WHITE);
           }
        }
    } ;
}
